/*
 * Created on 16.12.2004
 */
package net.hoopajoo.swingx;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.Action;
import javax.swing.JRadioButtonMenuItem;

/**
 * A special version of JRadioButtonMenuItem to be used with SelectedActions.
 * @author anttix 
 */
public class JSelectedRadioMenuItem extends JRadioButtonMenuItem {
    public JSelectedRadioMenuItem(SelectedAction a) {
        super( a );
    }
    protected void configurePropertiesFromAction(Action a) {
        super.configurePropertiesFromAction( a );
        setSelected( ((SelectedAction)a).isSelected() );
        setText( (String)a.getValue( SelectedAction.SHORT_DESCRIPTION ));
    }
    protected PropertyChangeListener createActionPropertyChangeListener(Action a) {
        a.addPropertyChangeListener( super.createActionPropertyChangeListener ( a ));
        
        return new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent evt) {
                if ( evt.getPropertyName().equals( SelectedAction.ACTION_SELECTED ) ) {
                    setSelected( ((Boolean)evt.getNewValue()).booleanValue() );
                }
                if ( evt.getPropertyName().equals( SelectedAction.SHORT_DESCRIPTION ) ) {
                    setText( (String)evt.getNewValue() );
                }
            }
        };
    }
}
